(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





(* :Context: XplorMath *)

(* :Title: 3D XplorMath surfacec converter *)

(* :Author: Xah Lee *)

(* : Copyright 2002 by Xah Lee.
*)

(* :Summary:
XplorMath.m is a Mathematica package, which displays 3D XplorMath surface data files into Mathematica.

This package is written by Xah Lee
email: xah@xahlee.org
website: http://xahlee.org/PageTwo_dir/more.html
3D XplorMath is a mathematics visualization software by Richard Palais, available at
http://rsp.math.brandeis.edu/3D-Filmstrip_html/3D-FilmstripHomePage.html
*)

(* :Keywords: 3dfs, 3dxm, 3D XplorMath, Graphics, geometry*)

(* :Mathematica Version: 3.0 *)
(* :Package Version: 2004-02-17 *)
(* :History:
First version: 2002-11-08
*)

(* :Sources: 
*)

(* :Warning: None. *)

(* :Limitations: *)

(* :Discussion:*)



BeginPackage["XplorMathConvert`","Utilities`FilterOptions`"];





Unprotect[ShowSurface];



Begin["`Private`"];



Clear[filetype,fileversion,uResolution,vResolution,numOfTiles,viewpointX,
    viewpointY,viewpointZ,viewDirectionX,viewDirectionY,viewDirectionZ,
    imagePlaneCenterX,imagePlaneCenterY,imagePlaneCenterZ,
    imagePlaneXDirectonX,imagePlaneXDirectonY,imagePlaneXDirectonZ,
    imagePlaneYDirectonX,imagePlaneYDirectonY,imagePlaneYDirectonZ,
    focalLength,graphicScale,eyeSeparation,clipDistance];
Clear[pointsData,transformMatrixData];
Clear[normalCorrectors];



Clear[fsParam];
fsParam={filetype,fileversion,uResolution,vResolution,numOfTiles,viewpointX,
      viewpointY,viewpointZ,viewDirectionX,viewDirectionY,viewDirectionZ,
      imagePlaneCenterX,imagePlaneCenterY,imagePlaneCenterZ,
      imagePlaneXDirectonX,imagePlaneXDirectonY,imagePlaneXDirectonZ,
      imagePlaneYDirectonX,imagePlaneYDirectonY,imagePlaneYDirectonZ,
      focalLength,graphicScale,eyeSeparation,clipDistance};





Clear[ShowSurface];
ShowSurface::"usage"=
    "ShowSurface[\"3dxm_surface_file\"] returns a Graphics3D object that \
represents the 3D XplorMath's surface data file. Example: \
ShowSurface[\"~/Documents/3dxm/Costa.surf\"]";

ShowSurface[file_String]:=
    Show@Module[{gp},assignParameters@readFile@file;
        gp=surfacedataToPolygon[pointsData];
        Graphics3D[
          If[numOfTiles==1,gp,defineTransformMatrixes@transformMatrixData;
            Table[gp/.Polygon[
                    ss_List]:>(Polygon[((rotationM[i]).#+translationM[i]&)/@
                        ss]),{i,1,numOfTiles}]]]];





Clear[readFile];
readFile[file_String]:=
    Module[{ff},ff=ReadList[file,Word,RecordSeparators\[Rule]"\r"];
      ff={First@ff}~
          Join~(ToExpression@StringReplace[#,"e"\[Rule]"*10^"]&/@(Rest@ff))];



Clear[assignParameters];
assignParameters[data_List]:=
    Module[{ptsStartLineNum,
        ptsEndLineNum},{filetype,fileversion,uResolution,vResolution,
          numOfTiles,viewpointX,viewpointY,viewpointZ,viewDirectionX,
          viewDirectionY,viewDirectionZ,imagePlaneCenterX,imagePlaneCenterY,
          imagePlaneCenterZ,imagePlaneXDirectonX,imagePlaneXDirectonY,
          imagePlaneXDirectonZ,imagePlaneYDirectonX,imagePlaneYDirectonY,
          imagePlaneYDirectonZ,focalLength,graphicScale,eyeSeparation,
          clipDistance}=Take[data,Length@fsParam];
      ptsStartLineNum=Length@fsParam+1;
      ptsEndLineNum=ptsStartLineNum+uResolution*vResolution*3-1;
      pointsData=Take[data,{ptsStartLineNum,ptsEndLineNum}];
      If[numOfTiles>1,
        transformMatrixData=
          Take[data,{ptsEndLineNum+1,ptsEndLineNum+12*numOfTiles}]];
      normalCorrectors=Take[data,{-numOfTiles,-1}];];



Clear[surfacedataToPolygon];
surfacedataToPolygon[numbers_List]:=
    Module[{gridMatrix,patch},
      gridMatrix=Partition[Partition[numbers,3],vResolution];patch={};
      For[u=1,u<uResolution,u++,
        For[v=1,v<vResolution,v++,
          patch={patch,
              Polygon@{gridMatrix[[u,v]],gridMatrix[[u,v+1]],
                  gridMatrix[[u+1,v+1]],gridMatrix[[u+1,v]]}}]];
      Flatten@patch];



Clear[defineTransformMatrixes];
defineTransformMatrixes[data_List]:=
    Module[{tempM},
      tempM=(Partition[#,3]&)/@(Transpose@(Partition[#,numOfTiles]&)@data);
      rotationM[x_Integer]:=Transpose@(tempM[[x]][[{1,2,3}]]);
      translationM[x_Integer]:=Last@tempM[[x]];];



End[];

Protect[ShowSurface];

EndPackage[];